round = function(float)
	return math.floor(float + 0.5)
end

local dir = defines.direction
local directiontable = {
	dir.north,
	dir.northeast,
	dir.east,
	dir.southeast,
	dir.south,
	dir.southwest,
	dir.west,
	dir.northwest,
	dir.north
}

int_to_vector = {
	{x = 0, y = -1},
	{x = 1, y = -1},
	{x = 1, y = 0},
	{x = 1, y = 1},
	{x = 0, y = 1},
	{x = -1, y = 1},
	{x = -1, y = 1},
	{x = -1, y = 0},
	{x = -1, y = -1}
}
ori_to_dir = function(ori)
	return directiontable[math.ceil(8*ori + 0.5)]
end

dir_to_int = function(direction)
	for i, d in pairs(directiontable) do
		if direction == d then return (i) end
	end
end

function moveposition(position, direction, distance)

  if direction == defines.direction.north then
    return {x = position.x, y = position.y - distance}
  end

  if direction == defines.direction.south then
    return {x = position.x, y = position.y + distance}
  end

  if direction == defines.direction.east then
    return {x = position.x + distance, y = position.y}
  end

  if direction == defines.direction.west then
    return {x = position.x - distance, y = position.y}
  end
end

function oppositedirection(direction)
  if direction == defines.direction.north then
    return defines.direction.south
  end

  if direction == defines.direction.south then
    return defines.direction.north
  end

  if direction == defines.direction.east then
    return defines.direction.west
  end

  if direction == defines.direction.west then
    return defines.direction.east
  end
end